t / test-lib.shon commit Move the user-facing test library to test-lib-functions.sh (12a29b1)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45unset VISUAL
  46unset EMAIL
  47unset LANGUAGE
  48unset $(perl -e '
  49        my @env = keys %ENV;
  50        my $ok = join("|", qw(
  51                TRACE
  52                DEBUG
  53                USE_LOOKUP
  54                TEST
  55                .*_TEST
  56                PROVE
  57                VALGRIND
  58        ));
  59        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  60        print join("\n", @vars);
  61')
  62GIT_AUTHOR_EMAIL=author@example.com
  63GIT_AUTHOR_NAME='A U Thor'
  64GIT_COMMITTER_EMAIL=committer@example.com
  65GIT_COMMITTER_NAME='C O Mitter'
  66GIT_MERGE_VERBOSITY=5
  67GIT_MERGE_AUTOEDIT=no
  68export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
  69export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  70export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  71export EDITOR
  72
  73# Protect ourselves from common misconfiguration to export
  74# CDPATH into the environment
  75unset CDPATH
  76
  77unset GREP_OPTIONS
  78
  79case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  80        1|2|true)
  81                echo "* warning: Some tests will not work if GIT_TRACE" \
  82                        "is set as to trace on STDERR ! *"
  83                echo "* warning: Please set GIT_TRACE to something" \
  84                        "other than 1, 2 or true ! *"
  85                ;;
  86esac
  87
  88# Convenience
  89#
  90# A regexp to match 5 and 40 hexdigits
  91_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  92_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  93
  94# Zero SHA-1
  95_z40=0000000000000000000000000000000000000000
  96
  97# Line feed
  98LF='
  99'
 100
 101# Each test should start with something like this, after copyright notices:
 102#
 103# test_description='Description of this test...
 104# This test checks if command xyzzy does the right thing...
 105# '
 106# . ./test-lib.sh
 107[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 108                TERM=$ORIGINAL_TERM &&
 109                export TERM &&
 110                [ -t 1 ] &&
 111                tput bold >/dev/null 2>&1 &&
 112                tput setaf 1 >/dev/null 2>&1 &&
 113                tput sgr0 >/dev/null 2>&1
 114        ) &&
 115        color=t
 116
 117while test "$#" -ne 0
 118do
 119        case "$1" in
 120        -d|--d|--de|--deb|--debu|--debug)
 121                debug=t; shift ;;
 122        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 123                immediate=t; shift ;;
 124        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 125                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 126        -h|--h|--he|--hel|--help)
 127                help=t; shift ;;
 128        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 129                verbose=t; shift ;;
 130        -q|--q|--qu|--qui|--quie|--quiet)
 131                # Ignore --quiet under a TAP::Harness. Saying how many tests
 132                # passed without the ok/not ok details is always an error.
 133                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 134        --with-dashes)
 135                with_dashes=t; shift ;;
 136        --no-color)
 137                color=; shift ;;
 138        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 139                valgrind=t; verbose=t; shift ;;
 140        --tee)
 141                shift ;; # was handled already
 142        --root=*)
 143                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 144                shift ;;
 145        *)
 146                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 147        esac
 148done
 149
 150if test -n "$color"; then
 151        say_color () {
 152                (
 153                TERM=$ORIGINAL_TERM
 154                export TERM
 155                case "$1" in
 156                        error) tput bold; tput setaf 1;; # bold red
 157                        skip)  tput bold; tput setaf 2;; # bold green
 158                        pass)  tput setaf 2;;            # green
 159                        info)  tput setaf 3;;            # brown
 160                        *) test -n "$quiet" && return;;
 161                esac
 162                shift
 163                printf "%s" "$*"
 164                tput sgr0
 165                echo
 166                )
 167        }
 168else
 169        say_color() {
 170                test -z "$1" && test -n "$quiet" && return
 171                shift
 172                echo "$*"
 173        }
 174fi
 175
 176error () {
 177        say_color error "error: $*"
 178        GIT_EXIT_OK=t
 179        exit 1
 180}
 181
 182say () {
 183        say_color info "$*"
 184}
 185
 186test "${test_description}" != "" ||
 187error "Test script did not set test_description."
 188
 189if test "$help" = "t"
 190then
 191        echo "$test_description"
 192        exit 0
 193fi
 194
 195exec 5>&1
 196exec 6<&0
 197if test "$verbose" = "t"
 198then
 199        exec 4>&2 3>&1
 200else
 201        exec 4>/dev/null 3>/dev/null
 202fi
 203
 204test_failure=0
 205test_count=0
 206test_fixed=0
 207test_broken=0
 208test_success=0
 209
 210test_external_has_tap=0
 211
 212die () {
 213        code=$?
 214        if test -n "$GIT_EXIT_OK"
 215        then
 216                exit $code
 217        else
 218                echo >&5 "FATAL: Unexpected exit with code $code"
 219                exit 1
 220        fi
 221}
 222
 223GIT_EXIT_OK=
 224trap 'die' EXIT
 225
 226# The user-facing functions are loaded from a separate file so that
 227# test_perf subshells can have them too
 228. "${TEST_DIRECTORY:-.}"/test-lib-functions.sh
 229
 230# You are not expected to call test_ok_ and test_failure_ directly, use
 231# the text_expect_* functions instead.
 232
 233test_ok_ () {
 234        test_success=$(($test_success + 1))
 235        say_color "" "ok $test_count - $@"
 236}
 237
 238test_failure_ () {
 239        test_failure=$(($test_failure + 1))
 240        say_color error "not ok - $test_count $1"
 241        shift
 242        echo "$@" | sed -e 's/^/#       /'
 243        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 244}
 245
 246test_known_broken_ok_ () {
 247        test_fixed=$(($test_fixed+1))
 248        say_color "" "ok $test_count - $@ # TODO known breakage"
 249}
 250
 251test_known_broken_failure_ () {
 252        test_broken=$(($test_broken+1))
 253        say_color skip "not ok $test_count - $@ # TODO known breakage"
 254}
 255
 256test_debug () {
 257        test "$debug" = "" || eval "$1"
 258}
 259
 260test_eval_ () {
 261        # This is a separate function because some tests use
 262        # "return" to end a test_expect_success block early.
 263        eval </dev/null >&3 2>&4 "$*"
 264}
 265
 266test_run_ () {
 267        test_cleanup=:
 268        expecting_failure=$2
 269        test_eval_ "$1"
 270        eval_ret=$?
 271
 272        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 273        then
 274                test_eval_ "$test_cleanup"
 275        fi
 276        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 277                echo ""
 278        fi
 279        return "$eval_ret"
 280}
 281
 282test_skip () {
 283        test_count=$(($test_count+1))
 284        to_skip=
 285        for skp in $GIT_SKIP_TESTS
 286        do
 287                case $this_test.$test_count in
 288                $skp)
 289                        to_skip=t
 290                        break
 291                esac
 292        done
 293        if test -z "$to_skip" && test -n "$test_prereq" &&
 294           ! test_have_prereq "$test_prereq"
 295        then
 296                to_skip=t
 297        fi
 298        case "$to_skip" in
 299        t)
 300                of_prereq=
 301                if test "$missing_prereq" != "$test_prereq"
 302                then
 303                        of_prereq=" of $test_prereq"
 304                fi
 305
 306                say_color skip >&3 "skipping test: $@"
 307                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 308                : true
 309                ;;
 310        *)
 311                false
 312                ;;
 313        esac
 314}
 315
 316test_done () {
 317        GIT_EXIT_OK=t
 318
 319        if test -z "$HARNESS_ACTIVE"; then
 320                test_results_dir="$TEST_DIRECTORY/test-results"
 321                mkdir -p "$test_results_dir"
 322                test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 323
 324                cat >>"$test_results_path" <<-EOF
 325                total $test_count
 326                success $test_success
 327                fixed $test_fixed
 328                broken $test_broken
 329                failed $test_failure
 330
 331                EOF
 332        fi
 333
 334        if test "$test_fixed" != 0
 335        then
 336                say_color pass "# fixed $test_fixed known breakage(s)"
 337        fi
 338        if test "$test_broken" != 0
 339        then
 340                say_color error "# still have $test_broken known breakage(s)"
 341                msg="remaining $(($test_count-$test_broken)) test(s)"
 342        else
 343                msg="$test_count test(s)"
 344        fi
 345        case "$test_failure" in
 346        0)
 347                # Maybe print SKIP message
 348                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 349
 350                if test $test_external_has_tap -eq 0; then
 351                        say_color pass "# passed all $msg"
 352                        say "1..$test_count$skip_all"
 353                fi
 354
 355                test -d "$remove_trash" &&
 356                cd "$(dirname "$remove_trash")" &&
 357                rm -rf "$(basename "$remove_trash")"
 358
 359                exit 0 ;;
 360
 361        *)
 362                if test $test_external_has_tap -eq 0; then
 363                        say_color error "# failed $test_failure among $msg"
 364                        say "1..$test_count"
 365                fi
 366
 367                exit 1 ;;
 368
 369        esac
 370}
 371
 372# Test the binaries we have just built.  The tests are kept in
 373# t/ subdirectory and are run in 'trash directory' subdirectory.
 374if test -z "$TEST_DIRECTORY"
 375then
 376        # We allow tests to override this, in case they want to run tests
 377        # outside of t/, e.g. for running tests on the test library
 378        # itself.
 379        TEST_DIRECTORY=$(pwd)
 380fi
 381GIT_BUILD_DIR="$TEST_DIRECTORY"/..
 382
 383if test -n "$valgrind"
 384then
 385        make_symlink () {
 386                test -h "$2" &&
 387                test "$1" = "$(readlink "$2")" || {
 388                        # be super paranoid
 389                        if mkdir "$2".lock
 390                        then
 391                                rm -f "$2" &&
 392                                ln -s "$1" "$2" &&
 393                                rm -r "$2".lock
 394                        else
 395                                while test -d "$2".lock
 396                                do
 397                                        say "Waiting for lock on $2."
 398                                        sleep 1
 399                                done
 400                        fi
 401                }
 402        }
 403
 404        make_valgrind_symlink () {
 405                # handle only executables, unless they are shell libraries that
 406                # need to be in the exec-path.  We will just use "#!" as a
 407                # guess for a shell-script, since we have no idea what the user
 408                # may have configured as the shell path.
 409                test -x "$1" ||
 410                test "#!" = "$(head -c 2 <"$1")" ||
 411                return;
 412
 413                base=$(basename "$1")
 414                symlink_target=$GIT_BUILD_DIR/$base
 415                # do not override scripts
 416                if test -x "$symlink_target" &&
 417                    test ! -d "$symlink_target" &&
 418                    test "#!" != "$(head -c 2 < "$symlink_target")"
 419                then
 420                        symlink_target=../valgrind.sh
 421                fi
 422                case "$base" in
 423                *.sh|*.perl)
 424                        symlink_target=../unprocessed-script
 425                esac
 426                # create the link, or replace it if it is out of date
 427                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 428        }
 429
 430        # override all git executables in TEST_DIRECTORY/..
 431        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 432        mkdir -p "$GIT_VALGRIND"/bin
 433        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 434        do
 435                make_valgrind_symlink $file
 436        done
 437        # special-case the mergetools loadables
 438        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 439        OLDIFS=$IFS
 440        IFS=:
 441        for path in $PATH
 442        do
 443                ls "$path"/git-* 2> /dev/null |
 444                while read file
 445                do
 446                        make_valgrind_symlink "$file"
 447                done
 448        done
 449        IFS=$OLDIFS
 450        PATH=$GIT_VALGRIND/bin:$PATH
 451        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 452        export GIT_VALGRIND
 453elif test -n "$GIT_TEST_INSTALLED" ; then
 454        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 455        error "Cannot run git from $GIT_TEST_INSTALLED."
 456        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 457        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 458else # normal case, use ../bin-wrappers only unless $with_dashes:
 459        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 460        if ! test -x "$git_bin_dir/git" ; then
 461                if test -z "$with_dashes" ; then
 462                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 463                fi
 464                with_dashes=t
 465        fi
 466        PATH="$git_bin_dir:$PATH"
 467        GIT_EXEC_PATH=$GIT_BUILD_DIR
 468        if test -n "$with_dashes" ; then
 469                PATH="$GIT_BUILD_DIR:$PATH"
 470        fi
 471fi
 472GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 473unset GIT_CONFIG
 474GIT_CONFIG_NOSYSTEM=1
 475GIT_ATTR_NOSYSTEM=1
 476export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 477
 478. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
 479
 480if test -z "$GIT_TEST_CMP"
 481then
 482        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 483        then
 484                GIT_TEST_CMP="$DIFF -c"
 485        else
 486                GIT_TEST_CMP="$DIFF -u"
 487        fi
 488fi
 489
 490GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 491export GITPERLLIB
 492test -d "$GIT_BUILD_DIR"/templates/blt || {
 493        error "You haven't built things yet, have you?"
 494}
 495
 496if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 497then
 498        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
 499        export GITPYTHONLIB
 500        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
 501                error "You haven't built git_remote_helpers yet, have you?"
 502        }
 503fi
 504
 505if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
 506        echo >&2 'You need to build test-chmtime:'
 507        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 508        exit 1
 509fi
 510
 511# Test repository
 512test="trash directory.$(basename "$0" .sh)"
 513test -n "$root" && test="$root/$test"
 514case "$test" in
 515/*) TRASH_DIRECTORY="$test" ;;
 516 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
 517esac
 518test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 519rm -fr "$test" || {
 520        GIT_EXIT_OK=t
 521        echo >&5 "FATAL: Cannot prepare test area"
 522        exit 1
 523}
 524
 525HOME="$TRASH_DIRECTORY"
 526export HOME
 527
 528test_create_repo "$test"
 529# Use -P to resolve symlinks in our working directory so that the cwd
 530# in subprocesses like git equals our $PWD (for pathname comparisons).
 531cd -P "$test" || exit 1
 532
 533this_test=${0##*/}
 534this_test=${this_test%%-*}
 535for skp in $GIT_SKIP_TESTS
 536do
 537        case "$this_test" in
 538        $skp)
 539                say_color skip >&3 "skipping test $this_test altogether"
 540                skip_all="skip all tests in $this_test"
 541                test_done
 542        esac
 543done
 544
 545# Provide an implementation of the 'yes' utility
 546yes () {
 547        if test $# = 0
 548        then
 549                y=y
 550        else
 551                y="$*"
 552        fi
 553
 554        while echo "$y"
 555        do
 556                :
 557        done
 558}
 559
 560# Fix some commands on Windows
 561case $(uname -s) in
 562*MINGW*)
 563        # Windows has its own (incompatible) sort and find
 564        sort () {
 565                /usr/bin/sort "$@"
 566        }
 567        find () {
 568                /usr/bin/find "$@"
 569        }
 570        sum () {
 571                md5sum "$@"
 572        }
 573        # git sees Windows-style pwd
 574        pwd () {
 575                builtin pwd -W
 576        }
 577        # no POSIX permissions
 578        # backslashes in pathspec are converted to '/'
 579        # exec does not inherit the PID
 580        test_set_prereq MINGW
 581        test_set_prereq SED_STRIPS_CR
 582        ;;
 583*CYGWIN*)
 584        test_set_prereq POSIXPERM
 585        test_set_prereq EXECKEEPSPID
 586        test_set_prereq NOT_MINGW
 587        test_set_prereq SED_STRIPS_CR
 588        ;;
 589*)
 590        test_set_prereq POSIXPERM
 591        test_set_prereq BSLASHPSPEC
 592        test_set_prereq EXECKEEPSPID
 593        test_set_prereq NOT_MINGW
 594        ;;
 595esac
 596
 597test -z "$NO_PERL" && test_set_prereq PERL
 598test -z "$NO_PYTHON" && test_set_prereq PYTHON
 599test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
 600test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
 601
 602# Can we rely on git's output in the C locale?
 603if test -n "$GETTEXT_POISON"
 604then
 605        GIT_GETTEXT_POISON=YesPlease
 606        export GIT_GETTEXT_POISON
 607        test_set_prereq GETTEXT_POISON
 608else
 609        test_set_prereq C_LOCALE_OUTPUT
 610fi
 611
 612# Use this instead of test_cmp to compare files that contain expected and
 613# actual output from git commands that can be translated.  When running
 614# under GETTEXT_POISON this pretends that the command produced expected
 615# results.
 616test_i18ncmp () {
 617        test -n "$GETTEXT_POISON" || test_cmp "$@"
 618}
 619
 620# Use this instead of "grep expected-string actual" to see if the
 621# output from a git command that can be translated either contains an
 622# expected string, or does not contain an unwanted one.  When running
 623# under GETTEXT_POISON this pretends that the command produced expected
 624# results.
 625test_i18ngrep () {
 626        if test -n "$GETTEXT_POISON"
 627        then
 628            : # pretend success
 629        elif test "x!" = "x$1"
 630        then
 631                shift
 632                ! grep "$@"
 633        else
 634                grep "$@"
 635        fi
 636}
 637
 638# test whether the filesystem supports symbolic links
 639ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
 640rm -f y
 641
 642# When the tests are run as root, permission tests will report that
 643# things are writable when they shouldn't be.
 644test -w / || test_set_prereq SANITY